
proc kdDBInit dbname {
    global kdPriv
    if [catch {set kdPriv(conn) \
	    [pg_connect $dbname -host localhost -port 5432]} error] {
	tk_dialog .error "Postgres Error" $error {} 0 OK
	
	#zruseni procedur
	foreach pr {kdDBExec kdDBTuple kdDBInsert kdDBunique pg_result} {
	    proc $pr args {}
	}
    }
}


proc kdDBExec {command} {
    global kdPriv
    return [pg_exec $kdPriv(conn) $command]
}
proc kdDBTuple {command} {
    global kdPriv
    set res [pg_exec $kdPriv(conn) $command]
    set tup [pg_result $res -getTuple 0]
    pg_result $res -clear
    return $tup
}
proc kdDBInsert {command} {
    global kdPriv
    set res [pg_exec $kdPriv(conn) $command]
    set id [pg_result $res -oid]
    pg_result $res -clear
    return $id
}
proc kdDBunique {} {
    global kdPriv
    set res [pg_exec $kdPriv(conn) "select uniquenum from kd_control"]
    set unum [pg_result $res -getTuple 0]
    pg_result $res -clear
    set res [pg_exec $kdPriv(conn) "update kd_control \
	    set uniquenum = [incr unum]"]
    pg_result $res -clear
    return $unum
}
