itcl_class kdDiagram {
    public name
    public id
    protected numbers 0
    
    constructor {config} {
    }
    destructor {
	#smazat vs. objekty
    }
    method new {class args} {
	global kdModel
	incr numbers
	eval $kdModel(cl,$class) o_${this}_$numbers \
		-class $class $args
    }
    method configure {config} {}

    method find {start args} {
	array set next_cl {-b -o   -o -l   -l -i   -i -b}
	array set part {-b Lines   -o Line   -l Boxes   -i Box}
	set cont $start
	set cl -[[$start info class] :: getType] 
	set maxi [llength $args]
	set i 0
	set prev ""
	while {$i < $maxi} {
	    set lcont ""
	    foreach c $cont {
		lappend lcont [$c get$part($cl)]
	    }
	    set n [lindex $args $i]
	    if ![regexp -- {-[bilo]} $n] {return "chyba: $n"}
	    if {$next_cl($cl) == $n} {
		#pridame tag a posuneme se na dalsi volbu
		set tag [lindex $args [incr i]]
		incr i
		set new ""
		foreach o [join $lcont] {
		    if [$o hasTag $tag]  {
			lappend new $o
		}   }   
	    } else {
		set new [join $lcont]
	    }
	    set new [unifyAndRemove $new $prev]
	    set prev $cont
	    set cont $new
	    set cl $next_cl($cl)
	}
	return $cont
    }

    method expandTemplate {template {indent 0}} {
	globap kdOps
	return [subst [readFile $kdOps(tempaleDir)/$template.tpl]]
    }
    method genFromTemplate {template {output {}}} {
	set diagram $this
	if {$output == ""} {
	    set output [kdEntryBox .gen Generate \
		    "Output file for generating '$template'" ""]
	}
	set ff [open $output w]
	puts $ff [expandTemplate $template]
	close $ff
    }

    common model
    array set model \
	    {kdBox cl_box  kdLine cl_line  kdConn cl_conn \
	    b cl_box   l cl_line   c cl_conn}

    method load {} {
	foreach cl {kdBox kdLine kdConn} {
	    set vars [concat {class objid} [$cl :: get_vnames]]
	    set res [kdDBExec "select [join $vars ", "] \
		    from $model($cl) where diag = '$id'"]
	    set count [pg_result $res -numTuples]
	    #set vars [lrange $vars 1 end]
	    set templ "-[join $vars { "%s" -}] \"%s\""
	    for {set i 0} {$i < $count} {incr i} {
		set tup [pg_result $res -getTuple $i]
		set class [lindex $tup 0]
		#set tup [lrange $tup 1 end]
		eval new $class -interactive 0 \
			[eval format {$templ} $tup]
	    }
	}
    }

    method save {} {
	set allobs [getObjects]
	#if not set objid, set it
	foreach ob $allobs {
	    if {[$ob get {$objid}] == 0} {
		$ob configure -objid [kdDBunique]
	}   }
	
	#make a script
	set commands "begin transaction; \n"
	#delete old ones
	append commands "delete from cl_box where diag = '$id';\n" \
		"delete from cl_line where diag = '$id';\n" \
		"delete from cl_conn where diag = '$id';\n"
	#insert current
	foreach ob $allobs {
	    set cl [$ob info class]
	    append commands "insert into $model($cl) " \
		    "([join [concat {diag objid class} \
		    [$cl :: get_vnames]] ", "] ) " \
		    " values( $id, '[$ob get {$objid}]', " \
		    " '[$ob get {$class}]', " \
		    " [join [$ob get_vals] ", "] ) ;\n"
	}
	append commands "end transaction;"
	#run the script
	kdDBExec $commands
    }

    method getObjects {{class {}}} {
	set ret ""
	if {$class == ""} {
	    return [itcl_info objects o_${this}_*]
	}
	foreach o [itcl_info objects o_${this}_* ] {
	    if {[lsearch [$o get {$findTags}] $class] >= 0} {
		lappend ret $o
	}   }
	return $ret
    }
}
    
proc expandeach {var list prefstr joinstr template} {
    set ll ""
    upvar  $var $var
    if [regexp {[0-9]+} $prefstr] {
	set prefstr [format "%${prefstr}s" ""]
    }
    foreach $var $list {
	lappend ll [uplevel subst "\{$template\}"]
    }
    regsub -all "\n" [join $ll $joinstr] "\n$prefstr" result
    return  $prefstr$result
}


proc unifyAndRemove {unsort remove} {
    set sort [lsort $unsort]
    set len [llength $sort]
    set ret ""
    set i 0
    set j 0
    set last ""
    set rem [lindex $remove 0]
    while {$i < $len} {
	set cur [lindex $sort $i]
	while {$cur > $rem && $rem != ""} {
	    set rem [lindex $remove [incr j]]
	}
	if {$cur != $last && $cur != $rem} {
	    #vkladame dalsi
	    lappend ret $cur
	    set last $cur
	}
	incr i
    }
    return $ret
}
	    
