
proc kdMakeMenu {menu items} {
    upvar this this
    if [catch {	
	set menu [frame $menu -relief groove -borderwidth 1]
	pack $menu -side top -fill x 
	set but 0 
    }] then {
	# menu exists
	set but [llength [info commands $menu.b\[0-9\]]]
    }
    kdSaveProcs {main check radio separator cascade command addUnderline}
    kdDefineMenuProcs
    eval $items
    kdRestoreProcs {main check radio separator cascade command addUnderline}
}

proc kdDefineMenuProcs {} {
    proc main {name body} {
	upvar menu menu  but but  this this
	# test whether exists
	set exists 0
	foreach m [info commands $menu.b\[0-9\]] {
	    if {[$m cget -text] == $name} {
		set exists 1
		break
	}   }
	set savedmenu $menu
	if $exists {
	    set menu $m.m
	} else {
	    # create new one
	    menubutton $menu.b$but -menu $menu.b$but.m -relief raised \
		    -text $name 
	    if [regsub ~ $name "" cname] {
		$menu.b$but configure -text $cname \
			-underline [string first ~ $name]
	    } else {
		$menu.b$but configure -underline 0
	    }
	    menu $menu.b$but.m -tearoff 0
	    pack $menu.b$but -side left
	    set menu $menu.b$but.m 
	}
	eval $body
	set menu $savedmenu
	incr but
    }
    proc addUnderline {menu label} {
	if [regsub ~ $label "" nlab] {
	    $menu entryconfigure last -label $nlab \
		    -underline [string first ~ $label]
	} else {
	    $menu entryconfigure last -underline 0
	}
    }	
    proc check {label var {comm ""}} {
	upvar menu menu
	$menu add checkbutton -label $label \
		-variable kdGlobal($var) -command $comm
	addUnderline $menu $label
    }
    proc radio {label var {comm ""}} {
	upvar menu menu 
	$menu add radiobutton -label $label \
		-variable kdGlobal($var) -command $comm
	addUnderline $menu $label
    }
    proc separator {} {
	upvar menu menu 
	$menu add separator
    }
    proc cascade {label body} {
	upvar menu menu  this this
	# test whether exists
	set exists 0
	set i 0
	while {$i <= [$menu index last]} {
	    if {[$menu entrycget $i -label] == $label} {
		set exists 1
		set sub [$menu entrycget $i -menu]
		break
	    } 
	    incr i
	}
	if !$exists {
	    # generovani jednoznacnyho jmena
	    set sub $menu.[string tolower [string range $label 0 3]]
	    $menu add cascade -label $label -menu $sub
	    addUnderline $menu $label
	    menu $sub -tearoff 0
	}
	set savedmenu $menu
	set menu $sub
	eval $body
	set menu $savedmenu
    }
    proc command {label comm} {
	upvar menu menu
	$menu add command -label $label -command $comm
	addUnderline $menu $label
    }
}
