itcl_class kdProject {
    public w
    public menu
    public list
    public name pokus
    protected IDdb
    protected diagrams ""
    common list_format "%-20s %-20s"
    
    constructor {config} {
	# previous constructor das
	if {$w == ""} {set w .$this}
	set menu $w.mb

	set IDdb 0

	makeOwnMenu
	pack [frame .pr -relief ridge -bd 2] -side top -fill x
	label .pr.l -anchor w -text "Project: "
	label .pr.n -anchor w -text $name \
		-font -*-helvetica-medium-r-*-120-*
	pack .pr.l .pr.n -side left -fill x

	frame .ls 
	pack .ls -side top -fill both
	makeList .ls

	wm minsize . 10 3
	wm title . Kredi
    }

    method makeOwnMenu {} {
	kdMakeMenu $menu { 
	    main System {
		command Info "$this show_info"
		separator
		command Exit "exit"
	    }
	    main Diagram {
		command Open "$this list_browse"
		cascade New {
		    command ERD "$this new_diagram erd"
		}
		command Print print_project
		command Rename "$this rename_diagram"
	    }
	    main View {
		check ERD view_ERD "$this fill_list"
		check DSD view_DSD "$this fill_list"
	    }		
	    main Functions {
		command "Check diagram" "$this check_diagram"
		command "Check model" "$this check_model"
	    }
	    main Options {
		command Diagram kd_not_supported
		command Printer kd_not_supported
	    }
	}   
    }
    

    method  makeList {f} {
	scrollbar $f.scroll -command "$f.list yview"
	pack $f.scroll -side right -fill y
	label $f.lab -text [format $list_format Name Date] \
		-font -*-courier-bold-r-*-120-*  -anchor w
	pack $f.lab -side top -fill x -expand yes
	listbox $f.list -yscroll "$f.scroll set" \
		-relief sunken  -height 7 \
		-setgrid yes  -selectmode extended -exportselection 0 \
		-font -*-courier-medium-r-*-120-*
	pack $f.list -side top -fill both -expand yes

	bind $f.list <Double-Button-1> "$this list_browse"
	set list $f.list
    }

    method fill_list {} {
	$list delete 0 end
	set res [kdDBExec "select oid,name,tmin from kd_diagram"]
	set count [pg_result $res -numTuples]
	catch {unset diagrams}
	pg_result $res -assign diagrams
	pg_result $res -clear
	for {set i 0} {$i < $count} {incr i} {
	    $list insert end [format $list_format \
		    $diagrams($i,name) \
		    [lrange $diagrams($i,tmin) 0 3]]
	    #awk -F: -vUID=$UID '$3 == UID {print $5}' /etc/passwd
	}
    }

    method list_browse {} {
	foreach i [$list curselection] {
	    kdEditor #auto -name $diagrams($i,name) \
		    -id $diagrams($i,oid)
	}
    }

#    method new_project {} {
#	set name [kdEntryBox .e Project "Name of new project:" ""]
#	set IDdb [kdDBInsert "insert into kd_database (name) \
#		values ( '$name' )"]
#	fill_list
#    }
    
#    method open_project {{proj {}}} {
#	if {$proj == ""} {
#	    set name [kdEntryBox .e Project "Project name:" ""]
#	} else {
#	    set name $proj
#	}
#	set IDdb [kdDBTuple "select oid from kd_database \
#		where name = '$name'"]
#	fill_list
#    }

    method new_diagram {type} {
	#!!! type 
	set dianame [kdEntryBox .e "New diagram" "Diagram name:" ""]
	set diaoid [kdDBInsert \
		"insert into kd_diagram (name) values('$dianame');"]
	fill_list
	kdEditor #auto -name $dianame -id $diaoid
    }
    
    method show_info {} {
	tk_dialog .info "Info" "Project: $name" "" 0 OK
    }
    
    method rename_diagram {} {
	set i [lindex [$list curselection] 0] 
	if {$i == ""} {
	    return
	}
	set dianame [kdEntryBox .e "Rename diagram" "New diagram name:" \
		$diagrams($i,name)]
	kdDBExec "update kd_diagram set name = '$dianame' \
		where oid = '$diagrams($i,oid)';"
	fill_list
    }
}


proc kdSelectDiagram {name diagram} {
    set res [kdDBExec "select  d.name from kd_diagram d, cl_box b \
	    where b.name = '$name' and b.diag = d.oid and \
	    d.name <> '$diagram' order by name" ]
    set count [pg_result $res -numTuples]
    if {$count == 1} {
	set diagram [pg_result $res -getTuple 0]
	kdEditor #auto -name $diagram \
	    -id [kdDBTuple "select oid from kd_diagram \
	    where name = '$diagram'"]
    } else {
	toplevel .sel
	wm title .sel Select
	listbox .sel.l -setgrid yes -selectmode single
	pack .sel.l -fill both -expand yes
	bind .sel.l <Double-Button-1> { 
	    kdEditor #auto -name [.sel.l get active] \
		    -id [kdDBTuple "select oid from kd_diagram \
		    where name = '[.sel.l get active]'"]
	    destroy .sel
	}

	for {set i 0} {$i < $count} {incr i} {
	    .sel.l insert end [lindex [pg_result $res -getTuple $i] 0]
	}
    }
    pg_result $res -clear
}

